$nocompile

Declare Sub 1wire_reset()
Declare Sub 1wire_write(byval Var As Byte)
Declare Function 1wire_writebyte(byval Var As Byte) As Byte
Declare Function 1wire_read() As Byte
Declare Function 1wire_err() As Byte

Const 1wire_9600 = _xtal /(9600 * 16) - 1
Const 1wire_115200 = _xtal /(115200 * 16) - 1

Dim 1wire_byte As Byte
Dim 1wire_errcode As Byte
Dim 1wire_i As Byte

Goto 1wire_usart

Function 1wire_err() As Byte
  1wire_err = 1wire_errcode
End Function

Sub 1wire_reset()
    Ubrr = 1wire_9600
   'Baud = 9600
   'Ucsr0a.1 = 0
   Gosub 1wire_clear_in_buff                      '   .
   1wire_errcode = 0

   Printbin &HF0                                  '     USART.
   1wire_byte = 20
   While 1wire_byte > 0
     Waitus 250
     Decr 1wire_byte

     If Ucsr0a.7 = 1 Then

       Inputbin 1wire_byte
       If 1wire_byte = &HF0 Then
         1wire_byte = 0
       Else
         1wire_byte = 1
       End If

       Exit While
     End If
   Wend
   Ubrr = 1wire_115200
   'Baud = 115200
   'Ucsr0a.1 = 0
   Toggle 1wire_byte.0

   1wire_errcode = 1wire_byte
End Sub

Function 1wire_writebyte(byval Var As Byte) As Byte

   For 1wire_i = 0 To 7

      If Var.0 = 1 Then
        Printbin &HFF
      Else
        Printbin &H00
      End If

      1wire_byte = 200
      While 1wire_byte > 0
        Waitus 50
        Decr 1wire_byte
        If Ucsr0a.7 = 1 Then
          Inputbin 1wire_byte
          Exit While
        End If
      Wend

      If 1wire_byte = &HFF Then
        Var.0 = 1
      Else
        Var.0 = 0
      End If

      Rotate Var , Right , 1

   Next

   1wire_writebyte = Var
End Function


Function 1wire_read() As Byte
  Gosub 1wire_clear_in_buff                       '   .

  1wire_errcode = 0
  1wire_byte = 1wire_writebyte(&Hff)
  1wire_read = 1wire_byte
End Function


Sub 1wire_write(byval Var As Byte)
  Gosub 1wire_clear_in_buff                       '   .
  1wire_errcode = 0
  1wire_byte = 1wire_writebyte(var)
End Sub


1wire_clear_in_buff:                              '   .
  While Ucsr0a.7 = 1
   Inputbin 1wire_byte
  Wend
Return

1wire_usart: